<template>
  <q-layout view="hHh lpR fFf" v-if="storeSet">
    <q-header elevated class="bg-primary text-white">
      <q-toolbar>
        <q-btn
          dense
          flat
          @click="leftDrawerOpen = !leftDrawerOpen"
          round
          icon="menu"
        />
        <q-toolbar-title>
          {{ $store.state.example.user.user.name }}
        </q-toolbar-title>
      </q-toolbar>
    </q-header>

    <q-drawer
      v-model="leftDrawerOpen"
      show-if-above
      bordered
      :width="250"
      :breakpoint="500"
      class="bg-grey-1 q-mt-md"
    >
      <q-list>
        <EssentialLink
          v-for="link in essentialLinks"
          :key="link.title"
          v-bind="link"
        />
      </q-list>
    </q-drawer>
    <q-page-container v-if="storeSet">
      <router-view />
    </q-page-container>
  </q-layout>
</template>

<script>
import EssentialLink from 'components/EssentialLink.vue'

import {mapActions} from 'vuex'
import axios from 'axios'

export default {
  name: 'MainLayout',
  components: { EssentialLink },
  data() {
    return {
      storeSet: false,
      menuItem: [],
      leftDrawerOpen: true,

      //essentialLinks: linksData,
      essentialLinks: [],
      menu:0,
    }
  },

    async mounted(){
    this.$q.loading.show()
    await this.AuthUser()

    //console.log(this.$store.state.example.user)
    var user_data = this.$store.state.example.userPermission;
    //console.log(user_data)
    var json = {}
    this.menuItem = []
    for(var i=0;i<user_data.length;i++){
      json = {
          title: user_data[i].title,
          icon: user_data[i].iconUrl,
          link: user_data[i].url,
        }
        if(user_data[i].read) this.menuItem.push(json)
    }
    this.menuItem.push({
      title: "Logout",
      icon: "logout",
      link: "logout"
    })
    this.essentialLinks = this.menuItem
    
  },

  methods:{
    ...mapActions('example', ['setUser']),
    async AuthUser(){
      await axios.get('http://127.0.0.1:8000/api/user/auth_user').then((res) => {
        this.$q.loading.hide()
        this.setUser({user: res.data.data[0]})
        this.storeSet = true
      }).catch((e)=>{
        var res = e.response
        this.$q.loading.hide()
        if(e.status == 401){
          this.$e("You are not authorized")
          this.$router.push('/login').then((s) => {}).catch((e) => {})
        }else{
          this.$e("Something Errors")
          this.$router.push('/login').then((s) => {}).catch((e) => {})
        }
      })
    }
  }
    
}
</script>

